/**
 * FastJack password cracker.
 * (K) 1998 by Kai Ruhl (KNR)
 * All rights reversed, all wrongs reserved. Runs under Gnu Public License
 * (GPL) - get this text from wherever u want. Most of all, have phun !
 * And dont become a commercial sucker - make the world a bit more free, teach
 * a hacker !
 * MailTo: FastJack@land-of-kain.de
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#define PASS_FILE_NAME ".pass"
#define DONE_FILE_NAME ".done"
#define FAIL_FILE_NAME ".fail"

#define STATUS_OK 0
#define STATUS_ERR -1
#define TRUE 1
#define FALSE 0

#define NAME_LEN 10
#define PASS_LEN 30
#define DESC_LEN 256
#define LINE_LEN 4096

#undef DEBUG

static FILE *oInFile, *oToFile, *oDoneFile, *oFailFile;

/* -------------------------------------------------------------------------- */

void copyRight()
{ /* Print copyleft and other important information.
   * Written by *me* (surprise).
   */
  printf( "\n%s\n", "FastJack password cracker. Written by Kai Ruhl (KNR)." );
  printf( "%s\n\n", "(K) All rights reversed, all wrongs reserved (GPL)." );
} /* copyRights() */

/* -------------------------------------------------------------------------- */

#define SHUT_FILE( SFile ) \
  fflush( SFile ); \
  fclose( SFile );

void shutFiles()
{ /* Closes all standard files.
   * Should be called by shutdown.
   */
  fclose( oInFile );
  SHUT_FILE( oToFile );
  SHUT_FILE( oDoneFile );
  SHUT_FILE( oFailFile );
} /* shutFiles() */

/* -------------------------------------------------------------------------- */

#define NAME_CONCAT( NTarget, N_EXTENSION ) \
  NTarget = (char *)(malloc( strlen( N_EXTENSION ) + iLen )); \
  strcpy( NTarget, pcInName ); strcat( NTarget, N_EXTENSION );

#define OPEN_FILE( OFile, OName, OMode, OPurpose ) \
  if ( NULL == (OFile = fopen( OName, OMode )) ) { \
    printf( "%s %s %s\n", "Unable to open", OPurpose, "file. Exiting." ); \
    shutFiles(); \
    exit( STATUS_ERR ); \
  } /* "if file couldnt be opened" */

void openFiles( char *pcInName )
{ /* Opens given input file.
   * Exits if not possible.
   */
  int iLen = strlen( pcInName );
  char *pcToName, *pcDoneName, *pcFailName;
  NAME_CONCAT( pcToName,   PASS_FILE_NAME );
  NAME_CONCAT( pcDoneName, DONE_FILE_NAME );
  NAME_CONCAT( pcFailName, FAIL_FILE_NAME );
  OPEN_FILE( oInFile, pcInName, "r", "input" );
  OPEN_FILE( oToFile, pcToName, "w", "output" );
  OPEN_FILE( oDoneFile, pcDoneName, "w", "done line" );
  OPEN_FILE( oFailFile, pcFailName, "w", "fail line" );
} /* openFiles() */

/* -------------------------------------------------------------------------- */

int crackWord( char *pcUsrName, char *pcPasswd, char *pcSalt, char *pcDicStr )
{ /* Checks if pcDicStr equals the password (of pcUsrName) held in pcPasswd by
   * given pcSalt. Returns 1 if successful, otherwise 0.
   */
  char *crypt( char pcPass[8], char pcSalt[2] );
  if ( ! (strcmp( pcPasswd, crypt( pcDicStr, pcSalt ) )) ) {
    fprintf( oToFile, "%s : %s : %s\n", pcUsrName, pcPasswd, pcDicStr );
    fflush( oToFile );
    return TRUE;
  } /* "given passwd is right" */
  return FALSE;
} /* crackWord( char*[4] ) */

/* -------------------------------------------------------------------------- */

int isLetter( char cLetter )
{ /* Checks if given char is a writing, means: A char that could belong to a
   * word: letters, digits, '-'. Returns 1 if successful, otherwise 0.
   */
  return( ((cLetter >= 'a') && (cLetter <= 'z')) ||
          ((cLetter >= 'A') && (cLetter <= 'Z')) ||
          ((cLetter >= '0') && (cLetter <= '9')) ||
          ('-' == cLetter)
        );
} /* isLetter( char ) */

/* -------------------------------------------------------------------------- */

#define CRACK_TOKEN \
  if ( TRUE == crackWord( pcUsrName, pcPasswd, pcSalt, pcToken ) ) { \
    return TRUE; \
  } /* "if cracked then end" */

#define ADVANCE_TO_LETTER \
  while ( ! isLetter( pcUserStr[iUsrPos] ) ) { \
    iUsrPos++; \
  } /* "while no letter" */

#define APPLY_TO_ALL_CHARS( AFunc, AStr, ALen ) \
  for ( iCnt = 0; iCnt < ALen; iCnt++ ) { \
    AStr[iCnt] = AFunc( AStr[iCnt] ); \
  } /* "apply char op to all" */

int crackUserStr( char *pcUsrName, char *pcPasswd, char *pcUserStr )
{ /* Tries to crack every token of given pcUserStr, where tokens are divided
   * by blanks or commas. Also tries complete upper and lower case of token.
   * Returns TRUE if successful, otherwise FALSE.
   */
  char pcSalt[2] = { pcPasswd[0], pcPasswd[1] };
  char cRead, pcToken[DESC_LEN];
  int iTokLen, iPos, iUsrPos = 0, iCnt;
  #ifdef DEBUG
    printf( "Full: " );
  #endif
  printf( "%s : %s : %s\n", pcUsrName, pcPasswd, pcUserStr );
  /* Skip spaces in beginning. */
  ADVANCE_TO_LETTER
  /* Now get all tokens. */
  while ( '\0' != pcUserStr[iUsrPos] ) {
    /* Get next token. */
    iPos = 0;
    while ( isLetter( (cRead = pcUserStr[iUsrPos]) ) ) {
      pcToken[iPos++] = cRead;
      iUsrPos++;
    } /* "read word" */
    pcToken[iPos] = '\0';
    iTokLen = iPos;
    /* Crack the shit ! */
    #ifdef DEBUG
      printf( "Part: %s : %s : %s\n", pcUsrName, pcPasswd, pcToken );
    #endif
    /* Try normal, downcased, upcased token. */
    CRACK_TOKEN
    APPLY_TO_ALL_CHARS( tolower, pcToken, iTokLen )
    CRACK_TOKEN
    APPLY_TO_ALL_CHARS( toupper, pcToken, iTokLen )
    CRACK_TOKEN
    /* Advance to next token. */
    if ( '\0' != pcUserStr[iUsrPos] ) {
      ADVANCE_TO_LETTER
    } /* "if end not reached" */
  } /* "while user string has more tokens" */
  return FALSE;
} /* crackUserStr( char*[3] ) */

/* -------------------------------------------------------------------------- */

#define READ_TO_DELIMITER( RTarget ) \
  for ( iPos = 0; pcLine[iRun] != ':'; iPos++, iRun++ ) { \
    RTarget[iPos] = pcLine[iRun]; \
  } /* "grep target" */ \
  RTarget[iPos] = '\0'; \
  iRun++;

#define SKIP_DELIMITER \
  while ( ':' != pcLine[iRun++] ) {}

void fastCrack()
{ /* Reads the passwd file and tries to crack every line.
   * Format of a line is assumed to be:
   * UserName:Passwd:UID:GID:Description:HomeDir:Shell
   * where only UserName, Passwd and Description matter.
   */
  char pcLine[LINE_LEN];
  char pcUsrName[NAME_LEN], pcPasswd[PASS_LEN], pcUserStr[DESC_LEN];
  char cRead;
  int iLen, iRun, iPos;
  /* Now, read line for line. and crack it. */
  while ( EOF != (pcLine[0] = fgetc( oInFile )) ) {
    /* Complete line read. */
    iRun = 0;
    iLen = 1;
    while ( '\n' != (cRead = fgetc( oInFile )) ) {
      pcLine[iLen++] = cRead;
    } /* "while chars in line" */
    pcLine[iLen] = '\0';
    /* Grep information. */
    READ_TO_DELIMITER( pcUsrName );
    READ_TO_DELIMITER( pcPasswd );
    SKIP_DELIMITER;
    SKIP_DELIMITER;
    READ_TO_DELIMITER( pcUserStr );
    /* Now crack it. */
    if ( TRUE == crackUserStr( pcUsrName, pcPasswd, pcUserStr ) ) {
      fprintf( oDoneFile, "%s\n", pcLine );
    } /* "if cracking successful" */
    else {
      fprintf( oFailFile, "%s\n", pcLine );
    } /* "if cracking failed" */
  } /* "while lines there" */
} /* fastCrack( void ) */

/* -------------------------------------------------------------------------- */

int main( int argc, char *argv[] ) {
  copyRight();
  if ( 2 != argc ) {
    printf( "%s\n\n", "FastJack Usage: jack <passwd file>" );
    exit( STATUS_ERR );
  } /* "not enough params" */
  openFiles( argv[1] );
  fastCrack();
  shutFiles();
  return STATUS_OK;
} /* main( int, char* ) */

/* ---- EOF ----------------------------------------------------------------- */
